(*********************************************
TDIBSprite->TSprite

This descendant of TSprite uses a TDIB to render
itself on a TWinGPaintBox

To construct, call the CreateDIBSprite constructor,
passing the TDIB to use as an image source.  Multiple
TDIBSprites can use the same TDIB as an image source.
*********************************************)

unit Dibsprit;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics, Controls, WinGPnt, Sprite, DIB;

type

  TDIBSprite = class( TSprite )
  private
     FDIB: TDIB;
     nWidth, nHeight: word;
  protected
     nWidthDiv2, nHeightDiv2: word;
     procedure Render( winGPnt: TWinGPaintBox ); override;
  public
     constructor CreateDIBSprite( dib: TDIB );
  end;

implementation

constructor TDIBSprite.CreateDIBSprite( dib: TDIB );
begin
  inherited Create;
  FDIB := dib;
  nWidth := FDIB.Width;
  nHeight := FDIB.Height;
  nWidthDiv2 := FDIB.Width div 2;
  nHeightDiv2 := FDIB.Height div 2;
end;

procedure TDIBSprite.Render( winGPnt: TWinGPaintBox );
begin
  winGPnt.RenderDIB( FDIB, Point( ptPhysical.X - nWidthDiv2, ptPhysical.Y - nHeightDiv2 ) );
end;

end.
