unit Odlist;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TOwnerDrawListBox = class( TListBox )
  private
     FSelectColor: TColor;
  protected
     procedure DrawItem( Index: Integer; Rect: TRect;
        State: TOwnerDrawState ); override;
  public
     constructor Create( AOwner: TComponent ); override;
  published
     property SelectColor: TColor read FSelectColor write FSelectColor default clNavy;
  end;

procedure Register;

implementation

constructor TOwnerDrawListBox.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Style := lbOwnerDrawFixed;
  ItemHeight := 18;
  FSelectColor := clNavy;
end;

procedure TOwnerDrawListBox.DrawItem( Index: Integer; Rect: TRect;
  State: TOwnerDrawState );
var
  clTemp: TColor;
begin
  with Canvas do
     begin
        if odSelected in State then
           Brush.Color := FSelectColor
        else
           Brush.Color := Color;
        Brush.Style := bsSolid;
        FillRect( Rect );
        Brush.Style := bsClear;
        clTemp := Font.Color;
        if odSelected in State then
           Font.Color := clWhite;
        inherited DrawItem( Index, Rect, State );
        Font.Color := clTemp;
     end;
end;

procedure Register;
begin
  RegisterComponents('Standard', [TOwnerDrawListBox]);
end;

end.
