unit Stringhl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms;

type
  TStringHolder = class(TComponent)
  private
     FStrings: TStrings;
  protected
     procedure SetStrings( sStrings: TStrings );
  public
     constructor Create( AOwner: TComponent ); override;
     destructor Destroy; override;
     procedure AssignSection( const sSection: string; str: TStrings );
  published
     property Strings: TStrings read FStrings write SetStrings;
  end;

procedure Register;

implementation

constructor TStringHolder.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  FStrings := TStringList.Create;
end;

destructor TStringHolder.Destroy;
begin
  FStrings.Free;
  inherited Destroy;
end;

procedure TStringHolder.SetStrings( sStrings: TStrings );
begin
  FStrings.Assign( sStrings );
end;

(*********************************************
Assign a "section" to another string list
*********************************************)
procedure TStringHolder.AssignSection( const sSection: string; str: TStrings );
var
  nIndex: integer;
  s: string;
begin
  str.Clear;
  nIndex := FStrings.IndexOf( '[' + sSection + ']' );
  if nIndex >= 0 then
     begin
        Inc( nIndex );
        while nIndex < FStrings.Count do
           begin
              s := FStrings[nIndex];
              if s[1] = '[' then
                 nIndex := FStrings.Count
              else
                 begin
                    str.Add( s );
                    Inc( nIndex );
                 end;
           end;
     end;
end;

procedure Register;
begin
  RegisterComponents('SilCmd', [TStringHolder]);
end;

end.
